
#include "headers.h"
#include "me.h"

#ifdef MIME

#include <errno.h>
#include <sys/stat.h>

/* Notice that ENCODING_ILLEGAL is -1 
 */

char *mime_encode_names[] = {
  "none", /* Not used. */
  "7bit",
  "8bit",
  "binary",
  "quoted-printable",
  "base64",
  "X-???"         /* ENCODING_EXPERIMENTAL */
};

int check_encoding(Encoding)
     char *Encoding;
{
  char *c, *d, tmp[VERY_LONG_STRING];
  int result =  ENCODING_ILLEGAL;

  dprint (9, (debugfile, "check_encoding(): Encoding=\"%s\"\n", Encoding));

  /* Don't harm "str" */
  strfcpy (tmp, Encoding, sizeof(tmp));
  
  rfc822_reap_comments (tmp, NULL, 0);
  c = tmp;
  d = tmp + strlen(tmp);

  while (d > tmp && whitespace(*(d-1)))
    d--;
  *d = '\0';
  while (*c && whitespace(*c))
    c++;

  if ('\0' == *c)
    result = ENCODING_7BIT;
  else if (strincmp(c, "x-", 2) == 0) 
    result = ENCODING_EXPERIMENTAL;
  else {
    int i;
    for (i = ENCODING_7BIT; i < ENCODING_EXPERIMENTAL; i++) {
      if (istrcmp(c, mime_encode_names[i]) == 0) {
	result = i;
	break;
      }
    }
  }

  dprint (9, (debugfile, "check_encoding()=%s (%d)\n",
	      ENCODING(result),result));
  return(result);
}

int charset_ok(s)
     char *s;
{
    /* Return true if configured charset could display us-ascii too */
    char buf[SLEN];	/* assumes sizeof(charset_compatlist) <= SLEN */
    char *bp, *chset;

    /* the "charset_compatlist[]" format is: */
    /*   charset charset charset ... */
    bp = strcpy(buf, charset_compatlist);
    while ((chset = strtok(bp, " \t\n")) != NULL) {
	bp = NULL;
	if (istrcmp(chset, s) == 0)
	    break;
    }

    /* see if we reached the end of the list without a match */
    if (chset == NULL) {
	return(FALSE);
    }
    return(TRUE);
}


#endif /* MIME */
